"use strict";
/*!
 *
 * Copyright 2017 - acrazing
 *
 * @author acrazing joking.young@gmail.com
 * @since 2017-08-22 22:17:46
 * @version 1.0.0
 * @desc misc.spec.ts
 */
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var fs = tslib_1.__importStar(require("fs"));
var node_fetch_1 = tslib_1.__importDefault(require("node-fetch"));
var path = tslib_1.__importStar(require("path"));
var parse_1 = require("./parse");
function run(url) {
    var id = url.replace(/[^\w\d]+/g, '_').replace(/^_+|_+$/g, '');
    console.log('Parsing %s', url);
    return node_fetch_1.default(url)
        .then(function (r) { return r.text(); })
        .then(function (d) {
        fs.writeFileSync(path.join(process.cwd(), 'temp', id + ".html"), d);
        var ast = parse_1.parse(d);
        fs.writeFileSync(path.join(process.cwd(), 'temp', id + ".json"), JSON.stringify(ast, void 0, 2));
        console.log('[OK]: %s, %s', id, url);
    })
        .catch(function (err) {
        console.error('[ERR]: %s, %s', id, err.message);
    });
}
var scenes = [
    'https://github.com/',
    'https://www.npmjs.com/',
    'https://www.zhihu.com/',
];
describe('real scenarios', function () {
    var e_1, _a;
    var _loop_1 = function (scene) {
        it("parse " + scene, function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
            return [2 /*return*/, run(scene)];
        }); }); });
    };
    try {
        for (var scenes_1 = tslib_1.__values(scenes), scenes_1_1 = scenes_1.next(); !scenes_1_1.done; scenes_1_1 = scenes_1.next()) {
            var scene = scenes_1_1.value;
            _loop_1(scene);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (scenes_1_1 && !scenes_1_1.done && (_a = scenes_1.return)) _a.call(scenes_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
});
//# sourceMappingURL=misc.spec.js.map