"use strict";
/*!
 *
 * Copyright 2017 - acrazing
 *
 * @author acrazing joking.young@gmail.com
 * @since 2017-08-19 00:54:46
 * @version 1.0.0
 * @desc walk.ts
 */
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
function visit(node, parent, index, options) {
    options.enter && options.enter(node, parent, index);
    if (node.type === types_1.SyntaxKind.Tag && Array.isArray(node.body)) {
        for (var i = 0; i < node.body.length; i++) {
            visit(node.body[i], node, i, options);
        }
    }
    options.leave && options.leave(node, parent, index);
}
function walk(ast, options) {
    for (var i = 0; i < ast.length; i++) {
        visit(ast[i], void 0, i, options);
    }
}
exports.walk = walk;
//# sourceMappingURL=walk.js.map